<template lang="html">
  <div id="profile-header">
    <div class="container">
      <div class="columns">
        <div class="column is-3">
          <div id="profile-picture-placeholder" v-if="profile.profilePicture.url==''">
            <i class="fas fa-user fa-3x"></i>
          </div>
          <figure class="image is-4by5">
            <img v-if="profile.profilePicture.url!='' && !profile.informations.blob" :src="'http://localhost:3000/profile-pictures/'+profile.profilePicture.url" alt="Responsive image">
            <img v-if="profile.informations.blob" :src="profile.informations.blob" alt="Responsive image">
          </figure>
        </div>
        <div class="column is-9">
          <div id="profile-header--informations" class="content">
            <div class="is-flex">
            <h1 class="title">{{profile.username}}</h1>
            <a class="button" v-if="!isProfileRoute" @click="follow()">
              <span class="icon" v-show="!isFollowingProfile">
                <i class="fa fa-rss"></i>
              </span>
              <span v-show="isFollowingProfile" class="icon">
                <i class="fa fa-check"></i>
              </span>
              <span v-if="!isFollowingProfile">
                S'abonner
              </span>
              <span v-if="isFollowingProfile">
                Abonné
              </span>
            </a>
            <a class="button is-danger" v-if="!isProfileRoute && isDifferentType && concertStep<0" @click="createConcert()">
              <span>
                Contacter
              </span>
            </a>
            <a class="button is-danger" v-if="concertStep>=0" @click="createConcert()">
              <span>
                Voir le concert
              </span>
            </a>
            </div>
            <p v-if="profile.informations.description">
              {{profile.informations.description}}
            </p>
            <span class="tag is-medium">
              {{profile.type}}
            </span>

          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapMutations } from 'vuex'
import Api from '@/api/Api'
export default {
  name:'ProfileHeader',
  props:['profile','authedProfile'],
  data(){
    return{
      concertStep:-1
    }
  },
  created(){
    this.getConcertStatus(this.profile.username);
  },
  computed:{
    isDifferentType(){
      return this.authedProfile.type != this.profile.type
    },
    isProfileRoute(){
      return this.authedProfile.username === this.profile.username
    },
    isFollowingProfile(){
      return this.authedProfile.followings && this.authedProfile.followings.length>=1 && this.authedProfile.followings.indexOf(this.profile.username) > -1;
    }

  },
  methods:{
    ...mapMutations('profile',['setAuthedProfile']),
    follow(){
      var newFollows;
      if(!this.isFollowingProfile){
        if(!this.authedProfile.followings || this.authedProfile.followings.length === 0){
          newFollows = [this.profile.username]
        }else {
          let flws = [[this.profile.username], this.authedProfile.followings];
          newFollows = [].concat(...flws);
        }
      }else {
        newFollows = [ ...this.authedProfile.followings ];
        const index = newFollows.indexOf(this.profile.username);
        newFollows.splice(index, 1);
      }
      var updatedAuthedProfile = { ...this.authedProfile ,...{followings:newFollows} };
      return Api.auth().put('/update',updatedAuthedProfile).then((res) =>
        {
          this.setAuthedProfile(updatedAuthedProfile);
        }).catch((res) => {
          return res
        })
    },
    createConcert(){
      const newConcert = {
        artist:this.authedProfile.type=='artist'?this.authedProfile.username:this.profile.username,
        exposant:this.authedProfile.type=='exposant'?this.authedProfile.username:this.profile.username,
        date_created:new Date(),
        step: 0
      }
      return Api.concerts().post('/create_concert',newConcert).then((res) =>
        {

        }).catch((res) => {
          return res
        })
    },
    getConcertStatus(profile){
      return Api.concerts().post('/get_concert',{authed:this.authedProfile.username,profile:profile}).then((res) =>
        {          
          if(res.data.concert.length>0){
            this.concertStep = res.data.concert[0].step
          }else {
            this.concertStep = -1;
            return false
          }
        }).catch((res) => {
          this.concertStep = -1;
          return false
        })
    }
  },
  watch: {
     '$route'(to,from){
       this.getConcertStatus(to.params.username)
     }
 }
}
</script>

<style lang="scss" scoped>
#profile-header {
  .container{
    padding-top: 2rem;
    padding-bottom: 2rem;
    width: 100%;
    img{
      border-radius: 6px;
    }
    #profile-header--informations {
      padding-left: 2rem;
      h1 {
        margin-right: 1rem;
      }
      a.button {
        margin-left: 1rem;
      }
    }

    #profile-picture-placeholder{
      width: 100%;
      border-radius: 5px;
      display: flex;
      justify-content: center;
      align-items: center;
      height: 100%;
      background: #f5f5f5;
      svg{
        opacity: 0.4
      }
    }
  }

}
</style>
